# Test AU using the ausdk

## Building

If this is a git repo, make sure you've run:

    git submodule update --init --recursive

If this is an archive, make sure you've copied the AudioUnit SDK into
audiounitsdk. You could do this by running:

    rmdir audiounitsdk
    git clone git@github.com:apple/audiounitsdk

The build is a normal CMake deal:

    cmake -B cmake-build-debug -G Ninja -D CMAKE_BUILD_TYPE=Debug
    cmake --build cmake-build-debug

Copy the AU bundle from `cmake-build-debug/testau.component` to
`~/Library/Audio/Plug-Ins/Components`.

## Testing

Test it 'works' (use Terminal, not iTerm):

    killall -9 AudioComponentRegistrar
    auval -v aumi Oooo Reuk

Load in Logic 10.7.1, followed by some kind of MIDI Logger (the JUCE MIDILogger
is a safe bet here).

Play a note on the on-screen keyboard in Logic.

### Result

In the MIDI Logger, you'll see 86 pitchbend messages, followed by nonsense.
Sometimes, Logic will crash.

### Expected result

Each time a note-on is played through the testau, the MIDI Logger should report
pitchbends cycling through all 16 MIDI channels 16 times, for a total of 256
messages.
